static QScriptValue moo_Document_objectToValue(QScriptEngine *engine, moo::Document* const &optr)
{
    return engine->newQObject(optr);
}

void moo_Document_valueToObject(const QScriptValue &value, moo::Document* &optr)
{
    optr = dynamic_cast<moo::Document*>(value.toQObject());
}

Q_DECLARE_METATYPE(moo::Document*)

static QScriptValue ggap_Worksheet_objectToValue(QScriptEngine *engine, ggap::Worksheet* const &optr)
{
    return engine->newQObject(optr);
}

void ggap_Worksheet_valueToObject(const QScriptValue &value, ggap::Worksheet* &optr)
{
    optr = dynamic_cast<ggap::Worksheet*>(value.toQObject());
}

Q_DECLARE_METATYPE(ggap::Worksheet*)

static QScriptValue ggap_WsWindow_objectToValue(QScriptEngine *engine, ggap::WsWindow* const &optr)
{
    return engine->newQObject(optr);
}

void ggap_WsWindow_valueToObject(const QScriptValue &value, ggap::WsWindow* &optr)
{
    optr = dynamic_cast<ggap::WsWindow*>(value.toQObject());
}

Q_DECLARE_METATYPE(ggap::WsWindow*)

static QScriptValue ggap_App_objectToValue(QScriptEngine *engine, ggap::App* const &optr)
{
    return engine->newQObject(optr);
}

void ggap_App_valueToObject(const QScriptValue &value, ggap::App* &optr)
{
    optr = dynamic_cast<ggap::App*>(value.toQObject());
}

Q_DECLARE_METATYPE(ggap::App*)


static void registerMetaTypes(QScriptEngine *engine)
{
    qScriptRegisterMetaType<moo::Document*>(engine, moo_Document_objectToValue, moo_Document_valueToObject);
    qScriptRegisterMetaType<ggap::Worksheet*>(engine, ggap_Worksheet_objectToValue, ggap_Worksheet_valueToObject);
    qScriptRegisterMetaType<ggap::WsWindow*>(engine, ggap_WsWindow_objectToValue, ggap_WsWindow_valueToObject);
    qScriptRegisterMetaType<ggap::App*>(engine, ggap_App_objectToValue, ggap_App_valueToObject);
}
